<?php
// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) exit;
?>

<p><?php _e('The \'Managed Servers\' section allows you to manage your cloud servers using a server management service. The FREE version of the plugin allows connection to ServerPilot, allowing new servers to be connected and WordPress websites to be installed and configured.', 'wp-cloud-server'); ?></p>
<p><?php _e('If you have another favourite service such as RunCloud or Ploi, or even Laravel Forge, then these can be added as add-on modules! These can be purchased from our the project webnsite and installed just like any other WordPress plugin.', 'wp-cloud-server'); ?></p>

<h2><?php _e('Server Management', 'wp-cloud-server'); ?></h2>
<p><?php _e('The \'Server Management\' menu will list all of the available services. Having just installed the \'WP Cloud Server\' plugin, and with both default modules activated, it will list \'ServerPilot\' as the default option. Clicking this menu option will display a page with tabbed options. This is where you can view all of the services provided by the \'ServerPilot\' module. The \'Websites\' and \'Servers\' tabs list all of the websites or servers already installed. Whereas the options starting with \'+ Add ...\' are where you can manually connect new servers and install new websites.', 'wp-cloud-server'); ?></p>
<p><?php _e('Where possible the plugin will automate all aspects of connecting a new server to your favourite service. With ServerPilot a new server needs to be created first and then connected to ServerPilot to install the server software and install WordPress.', 'wp-cloud-server'); ?></p>
<p><?php _e('The following steps happen in the background without you having to worry!', 'wp-cloud-server'); ?></p>
<ol>
	<li><?php _e('Notify ServerPilot that a new server is being connected and provide it\'s name.', 'wp-cloud-server'); ?></li>
	<li><?php _e('Create a new server with DigitalOcean, or another cloud provider.', 'wp-cloud-server'); ?></li>
	<li><?php _e('Automatically installs the ServerPilot install agent to let ServerPilot work it\'s magic', 'wp-cloud-server'); ?></li>
</ol>

<h2><?php _e('Selling Hosting Plans with WooCommerce or Easy Digital Downloads', 'wp-cloud-server'); ?></h2>
<p><?php _e("Support for 'WooCommerce' and 'Easy Digital Downloads' is built-in to the \'WP Cloud Server\' plugin. If you have either of these powerful eCommerce plugins installed then you will see some additional tabs automatically added, including 'Templates', '+ Add Template', and 'Client Details'.
", 'wp-cloud-server'); ?></p>

<h3><?php _e('Website Hosting Plan Templates', 'wp-cloud-server'); ?></h3>
<p><?php _e('\'Templates\' are a very powerful feature built-in to the plugin. A \'Template\' is a way of grouping together a set of server or website features that can be selected inside a \'WooCommerce\' or \'Easy Digital Downloads\' product page, and can then be sold to clients or customers. When a web hosting plan is sold and payment has been confirmed the \'Template\' is used to automatically create the server and webiste.
', 'wp-cloud-server'); ?></p>
<p><?php _e('You can create any number of \'Templates\' and view them in the \'Templates\' tab, where you can manage and delete templates. Each \'Templates\' row includes a \'Sites\' field that shows how many web sites have been created using the template.', 'wp-cloud-server'); ?></p>
<h3><?php _e('Client Details', 'wp-cloud-server'); ?></h3>
<p><?php _e('The final tab called \'Clients\' links customers details to hosting plans, so that you can see at a glance which clients have what hosting plans.', 'wp-cloud-server'); ?></p>

