<?php
/**
 * WP Cloud Server Config File
 *
 */

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) exit;

function wpcs_setup_aws_lightsail_config( $modules, $module_name, $status ) {

$debug_enabled = get_option( 'wpcs_enable_debug_mode' );

/**
 * GLOBAL ARGUMENTS
 */

$kses_exceptions = array(
	'a'      => array(
		'href' => array(),
	),
	'strong' => array(),
	'br'     => array(),
);

require_once WPCS_AWS_LIGHTSAIL_PLUGIN_DIR . 'includes/config/templates/aws-lightsail-settings.php';
require_once WPCS_AWS_LIGHTSAIL_PLUGIN_DIR . 'includes/config/templates/aws-lightsail-logged-data.php';
require_once WPCS_AWS_LIGHTSAIL_PLUGIN_DIR . 'includes/config/templates/aws-lightsail-debug.php';
require_once WPCS_AWS_LIGHTSAIL_PLUGIN_DIR . 'includes/config/templates/aws-lightsail-license-settings.php';

require_once WPCS_AWS_LIGHTSAIL_PLUGIN_DIR . 'includes/config/templates/aws-lightsail-server-details.php';
require_once WPCS_AWS_LIGHTSAIL_PLUGIN_DIR . 'includes/config/templates/aws-lightsail-template-details.php';
require_once WPCS_AWS_LIGHTSAIL_PLUGIN_DIR . 'includes/config/templates/aws-lightsail-client-details.php';
require_once WPCS_AWS_LIGHTSAIL_PLUGIN_DIR . 'includes/config/templates/aws-lightsail-add-server.php';
require_once WPCS_AWS_LIGHTSAIL_PLUGIN_DIR . 'includes/config/templates/aws-lightsail-add-template.php';
	
require_once WPCS_AWS_LIGHTSAIL_PLUGIN_DIR . 'includes/config/templates/aws-lightsail-backup-details.php';
require_once WPCS_AWS_LIGHTSAIL_PLUGIN_DIR . 'includes/config/templates/aws-lightsail-snapshot-details.php';

/*
 *
 * ---> BEGIN SECTIONS
 *
 */

/* -> START WordPress Sub Menu. */

if ( ( 'AWS Lightsail' == $module_name ) && ( '' !== $status ) ) {
	$modules[$module_name]['status'] = $status;
	update_option( 'wpcs_module_list', $modules );
}

$modules			= get_option( 'wpcs_module_list' );
$activated			= ( isset( $modules[ 'AWS Lightsail']['status'] ) && ( 'active' == $modules[ 'AWS Lightsail']['status'] ) ) ? 'true' : 'false';
$config				= get_option( 'wpcs_module_config' );
$page_position 		= ( $debug_enabled ) ? '10' : '9';
$active_tab			= ( $debug_enabled ) ? 'true' : 'false';

$sub_menu = array(
	'id'       		=> 'aws-lightsail-settings',
	'module'		=>  'AWS Lightsail',
	'active'		=> $activated,
	'position'		=> $page_position,
	'template'		=> 'aws-lightsail-settings',
	'template_path'	=> 'includes/config/templates/',
	'menu_header'	=> '',
	'menu_divider'	=> '',
	'menu_item'		=>  'AWS Lightsail',
	'type'     		=> 'settings',
	'title'    		=> '',
	'subtitle' 		=> '',
	'desc'     		=> '',
	'tab_block_id'	=> 'aws_lightsail_tabs',
	'tabs'			=> array(
		'tab1'		=>	'Settings',
		'tab2'		=>	'Event Log',
		'tab3'		=>	'Debug',
	),
	'tabs_content'	=> array(
		'tab1'		=>	'aws-lightsail-settings',
		'tab2'		=>	'aws-lightsail-logged-data',
		'tab3'		=>	'aws-lightsail-debug',
	),
	'tabs_active'	=> array(
		'tab1'		=>	'true',
		'tab2'		=>	'true',
		'tab3'		=>	$active_tab,
	),
	'tabs_width'	=> array(
		'tab1'		=>	'xsmall',
		'tab2'		=>	'',
		'tab3'		=>	'',
	),
);

$config[ 'wp-cloud-server-admin-menu' ]['content'][$sub_menu['id']] = $sub_menu;

$config[ 'wp-cloud-server-admin-menu' ][ 'AWS Lightsail' ] = $sub_menu;

$linode[$sub_menu['id']] = $sub_menu;

$sub_menu = array(
			'id'       		=> 'aws-lightsail-server-details',
			'module'		=> 'AWS Lightsail',
			'active'		=> $activated,
			'position'		=> '9',
			'template'		=> 'aws-lightsail-server-details',
			'template_path'	=> 'includes/config/templates',
			'menu_header'	=> 'Manage',
			'menu_divider'	=> 'yes',
			'menu_item'		=>  'Instances',
			'type'     		=> 'text',
			'api_required'	=> array( 'aws lightsail'),
			'title'    		=> 'AWS Lightsail Linux Servers',
			'subtitle' 		=> '',
			'desc'     		=> '',
			'tab_block_id'	=> 'aws_lightsail_tabs',
					'tabs'			=> array(
						'tab1'		=>	'Servers',
						'tab2'		=>	'Templates',
						'tab3'		=>	'+ Add Server',
						'tab4'		=>	'+ Add Template',
						'tab5'		=>	'Clients',
					),
					'tabs_content'	=> array(
						'tab1'		=>	'aws-lightsail-server-details',
						'tab2'		=>	'aws-lightsail-template-details',
						'tab3'		=>	'aws-lightsail-add-server',
						'tab4'		=>	'aws-lightsail-add-template',
						'tab5'		=>	'aws-lightsail-client-details',
					),
					'tabs_active'	=> array(
						'tab1'		=>	'true',
						'tab2'		=>	wpcs_cart_active(),
						'tab3'		=>	'true',
						'tab4'		=>	wpcs_cart_active(),
						'tab5'		=>	wpcs_cart_active(),
					),
					'tabs_width'	=> array(
						'tab1'		=>	'',
						'tab2'		=>	'',
						'tab3'		=>	'xsmall',
						'tab4'		=>	'xsmall',
						'tab5'		=>	'',
					),
		);

$config[ 'wp-cloud-servers-aws-lightsail' ][ 'AWS Lightsail' ][0] = $sub_menu;

$sub_menu = array(
			'id'       		=> 'aws-lightsail-backup-details',
			'module'		=> 'AWS Lightsail',
			'active'		=> 'false',
			'position'		=> '9',
			'template'		=> 'aws-lightsail-backup-details',
			'template_path'	=> 'includes/config/templates',
			'menu_header'	=> '',
			'menu_divider'	=> '',
			'menu_item'		=> 'Snapshots',
			'section_width'	=> '',
			'type'     		=> 'text',
			'api_required'	=> array( 'upcloud'),
			'title'    		=> 'AWS Lightsail Servers',
			'subtitle' 		=> '',
			'desc'     		=> '',
			'tab_block_id'	=> 'aws-lightsail_backup_tabs',
					'tabs'			=> array(
						'tab1'		=>	'Snapshots',
						'tab2'		=>	'Backups',
					),
					'tabs_content'	=> array(
						'tab1'		=>	'aws-lightsail-snapshot-details',
						'tab2'		=>	'aws-lightsail-backup-details',
					),
					'tabs_active'	=> array(
						'tab1'		=>	'true',
						'tab2'		=>	'true',
					),
					'tabs_width'	=> array(
						'tab1'		=>	'',
						'tab2'		=>	'',
					),
);

$config[ 'wp-cloud-servers-aws-lightsail' ]['AWS Lightsail'][1] = $sub_menu;

/*
 * <--- END MENU CONFIGURATION
 */

if ( function_exists( 'wpcs_setup_aws_lightsail_pro_config' ) ) {
	$config = wpcs_setup_aws_lightsail_pro_config( $config );
}

update_option( 'wpcs_aws_lightsail_module_config', $linode );

update_option( 'wpcs_module_config', $config );

}
add_action( 'wpcs_update_module_config', 'wpcs_setup_aws_lightsail_config', 10, 3 );