<?php
/**
 * WP Cloud Server Config File
 *
 */

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) exit;

function wpcs_setup_cloudways_config( $modules, $module_name, $status ) {

$debug_enabled = get_option( 'wpcs_enable_debug_mode' );

/**
 * GLOBAL ARGUMENTS
 */

$kses_exceptions = array(
	'a'      => array(
		'href' => array(),
	),
	'strong' => array(),
	'br'     => array(),
);

// Get the module view tab content
require_once WPCS_CLOUDWAYS_PLUGIN_DIR . 'includes/config/templates/cloudways-settings.php';
require_once WPCS_CLOUDWAYS_PLUGIN_DIR . 'includes/config/templates/cloudways-logged-data.php';
require_once WPCS_CLOUDWAYS_PLUGIN_DIR . 'includes/config/templates/cloudways-debug.php';

// Get the managed hosting tab content
require_once WPCS_CLOUDWAYS_PLUGIN_DIR . 'includes/config/templates/cloudways-client-details.php';
require_once WPCS_CLOUDWAYS_PLUGIN_DIR . 'includes/config/templates/cloudways-server-details.php';
require_once WPCS_CLOUDWAYS_PLUGIN_DIR . 'includes/config/templates/cloudways-application-details.php';
require_once WPCS_CLOUDWAYS_PLUGIN_DIR . 'includes/config/templates/cloudways-template-details.php';
require_once WPCS_CLOUDWAYS_PLUGIN_DIR . 'includes/config/templates/cloudways-create-server.php';
require_once WPCS_CLOUDWAYS_PLUGIN_DIR . 'includes/config/templates/cloudways-create-application.php';
require_once WPCS_CLOUDWAYS_PLUGIN_DIR . 'includes/config/templates/cloudways-create-template.php';
	
require_once WPCS_CLOUDWAYS_PLUGIN_DIR . 'includes/config/templates/cloudways-add-ons.php';

/*
 *
 * ---> BEGIN SECTIONS
 *
 */

/* -> START WordPress Sub Menu. */
//update_option( 'wpcs_cloudways_server_complete_queue', array() );

$modules	= get_option( 'wpcs_module_list' );

$activated	= ( isset($modules['Cloudways']['status']) && ( 'active' == $modules['Cloudways']['status'] ) ) ? 'true' : 'false';

//delete_option( 'wpcs_module_config' );

$config		= get_option( 'wpcs_module_config' );

$page_position = ( $debug_enabled ) ? '10' : '9';
$active_tab		= ( $debug_enabled ) ? 'true' : 'false';

$sub_menu = array(
	'id'       		=> 'cloudways-settings',
	'module'		=> 'Cloudways',
	'active'		=> $activated,
	'position'		=> $page_position,
	'template'		=> 'cloudways-settings',
	'template_path'	=> 'includes/config/templates/',
	'menu_header'	=> '',
	'menu_divider'	=> '',
	'menu_item'		=> 'Cloudways',
	'type'     		=> 'settings',
	'title'    		=> '',
	'subtitle' 		=> '',
	'desc'     		=> '',
	'tab_block_id'	=> 'cloudways_tabs',
	'tabs'			=> array(
		'tab1'		=>	'Settings',
		'tab2'		=>	'Event Log',
		'tab3'		=>	'Debug',
	),
	'tabs_content'	=> array(
		'tab1'		=>	'cloudways-settings',
		'tab2'		=>	'cloudways-logged-data',
		'tab3'		=>	'cloudways-debug',
	),
	'tabs_active'	=> array(
		'tab1'		=>	'true',
		'tab2'		=>	'true',
		'tab3'		=>	$active_tab,
	),
	'tabs_width'	=> array(
		'tab1'		=>	'xsmall',
		'tab2'		=>	'',
		'tab3'		=>	$active_tab,
	),
);

$config[ 'wp-cloud-server-admin-menu' ]['content'][$sub_menu['id']] = $sub_menu;

$config[ 'wp-cloud-server-admin-menu' ]['Cloudways'] = $sub_menu;

$cloudways[$sub_menu['id']] = $sub_menu;

$sub_menu = array(
			'id'       		=> 'cloudways-server-details',
			'module'		=> 'Cloudways',
			'active'		=> $activated,
			'position'		=> '9',
			'template'		=> 'cloudways-server-details',
			'template_path'	=> 'includes/config/templates',
			'menu_header'	=> '',
			'menu_divider'	=> '',
			'menu_item'		=> 'Servers',
			'type'     		=> 'text',
			'api_required'	=> array( 'cloudways'),
			'title'    		=> 'Cloudways Servers',
			'subtitle' 		=> '',
			'desc'     		=> '',
			'tab_block_id'	=> 'cloudways_tabs',
					'tabs'			=> array(
						'tab1'		=>	'Servers',
						'tab2'		=>	'Templates',
						'tab3'		=>	'+ Add Server',
						'tab4'		=>	'+ Add Template',
						'tab5'		=>	'Clients',
					),
					'tabs_content'	=> array(
						
						'tab1'		=>	'cloudways-server-details',
						'tab2'		=>	'cloudways-template-details',
						'tab3'		=>	'cloudways-create-server',
						'tab4'		=>	'cloudways-create-template',
						'tab5'		=>	'cloudways-client-details',
					),
					'tabs_active'	=> array(
						'tab1'		=>	'true',
						'tab2'		=>	wpcs_cart_active(),
						'tab3'		=>	'true',
						'tab4'		=>	wpcs_cart_active(),
						'tab5'		=>	wpcs_cart_active(),
					),
					'tabs_width'	=> array(
						'tab1'		=>	'',
						'tab2'		=>	'',
						'tab3'		=>	'xsmall',
						'tab4'		=>	'xsmall',
						'tab5'		=>	'',
					),
);

$config[ 'wp-cloud-server-managed-hosting' ]['Cloudways'][0] = $sub_menu;
	
$sub_menu = array(
			'id'       		=> 'cloudways-app-details',
			'module'		=> 'Cloudways',
			'active'		=> $activated,
			'position'		=> '9',
			'template'		=> 'cloudways-app-details',
			'template_path'	=> 'includes/config/templates',
			'menu_header'	=> '',
			'menu_divider'	=> '',
			'menu_item'		=> 'Applications',
			'type'     		=> 'text',
			'api_required'	=> array( 'cloudways'),
			'title'    		=> 'Cloudways Servers',
			'subtitle' 		=> '',
			'desc'     		=> '',
			'tab_block_id'	=> 'cloudways_application_tabs',
					'tabs'			=> array(
						'tab1'		=>	'Applications',
						'tab2'		=>	'+ Add Application',
					),
					'tabs_content'	=> array(
						'tab1'		=>	'cloudways-application-details',
						'tab2'		=>	'cloudways-create-application',
					),
					'tabs_active'	=> array(
						'tab1'		=>	'true',
						'tab2'		=>	'true',
					),
					'tabs_width'	=> array(
						'tab1'		=>	'',
						'tab2'		=>	'xsmall',
					),
);

$config[ 'wp-cloud-server-managed-hosting' ]['Cloudways'][1] = $sub_menu;

$sub_menu = array(
			'id'       		=> 'cloudways-add-ons',
			'module'		=> 'Cloudways',
			'active'		=> 'false',
			'position'		=> '9',
			'template'		=> 'cloudways-add-ons',
			'template_path'	=> 'includes/config/templates',
			'menu_header'	=> '',
			'menu_divider'	=> '',
			'menu_item'		=> 'Add-ons',
			'section_width'	=> '',
			'type'     		=> 'text',
			'api_required'	=> array( 'cloudways'),
			'title'    		=> 'Cloudways Servers',
			'subtitle' 		=> '',
			'desc'     		=> '',
			'tab_block_id'	=> 'cloudways_addon_tabs',
					'tabs'			=> array(
						'tab1'		=>	'Add-ons',
						'tab2'		=>	'Add-ons',
					),
					'tabs_content'	=> array(
						'tab1'		=>	'cloudways-add-ons',
						'tab2'		=>	'cloudways-add-ons',
					),
					'tabs_active'	=> array(
						'tab1'		=>	'true',
						'tab2'		=>	'true',
					),
					'tabs_width'	=> array(
						'tab1'		=>	'',
						'tab2'		=>	'',
					),
);

$config[ 'wp-cloud-server-managed-hosting' ]['Cloudways'][2] = $sub_menu;

/*
 * <--- END MENU CONFIGURATION
 */

if ( function_exists( 'wpcs_setup_cloudways_pro_config' ) ) {
	$config = wpcs_setup_cloudways_pro_config( $config );
}

update_option( 'wpcs_cloudways_module_config', $cloudways );

update_option( 'wpcs_module_config', $config );

}
add_action( 'wpcs_update_module_config', 'wpcs_setup_cloudways_config', 10, 3 );