<?php

function wpcs_cloudways_settings_template ( $tabs_content ) {
	
	if ( 'cloudways-settings' !== $tabs_content ) {
		return;
	}
				
	$nonce		= isset( $_GET['_wpnonce'] ) ? sanitize_text_field( $_GET['_wpnonce'] ) : ''; 
	$reset_api	= isset( $_GET['resetapi'] ) ? wpcs_sanitize_true_setting( $_GET['resetapi'] ) : '';
	
	if (( 'true' == $reset_api ) && ( current_user_can( 'manage_options' ) ) && ( wp_verify_nonce( $nonce, 'cloudways_settings_nonce' ) ) ) {
		delete_option( 'wpcs_cloudways_email' );
		delete_option( 'wpcs_cloudways_api_key' );
		delete_option( 'wpcs_dismissed_cloudways_api_notice' );
		echo '<script type="text/javascript"> window.location.href =  window.location.href.split("&")[0]; </script>';
	}
	?>

		<div class="content">
			<form method="post" action="options.php">
				<?php 
				wpcs_settings_fields( 'wpcs_cloudways_admin_menu', 'cloudways' );
				wpcs_do_settings_sections( 'wpcs_cloudways_admin_menu' );
				?>
				<hr>
				<?php
				wpcs_submit_button( 'Save Settings', 'secondary', 'create_cloudways_api' );
				?>
			</form>
		</div>
		<p>
			<a class="uk-link" href="<?php echo esc_url( wp_nonce_url( self_admin_url( 'admin.php?page=wp-cloud-server-admin-menu&tab=digitalocean&submenu=settings&resetapi=true' ), 'cloudways_settings_nonce', '_wpnonce') );?>"><?php esc_attr_e( 'Reset Cloudways API Credentials', 'wp-cloud-server' ) ?></a>
		</p>

<?php
}

add_action( 'wpcs_control_panel_tab_content', 'wpcs_cloudways_settings_template' );