<?php
/**
 * WP Cloud Server DigitalOcean Config File
 *
 */

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) exit;

function wpcs_setup_digitalocean_config( $modules, $module_name, $status ) {

$debug_enabled = get_option( 'wpcs_enable_debug_mode' );

/**
 * GLOBAL ARGUMENTS
 */

$kses_exceptions = array(
	'a'      => array(
		'href' => array(),
	),
	'strong' => array(),
	'br'     => array(),
);

/*
 *
 * ---> BEGIN SECTIONS
 *
 */

/* -> START WordPress Sub Menu. */

if ( ( 'DigitalOcean' == $module_name ) && ( '' !== $status ) ) {
	$modules[$module_name]['status'] = $status;
	update_option( 'wpcs_module_list', $modules );
}

//$modules		= get_option( 'wpcs_module_list' );
$activated		= ( isset( $modules['DigitalOcean']['status'] ) && ( 'active' == $modules['DigitalOcean']['status'] ) ) ? 'true' : 'false';
$config			= get_option( 'wpcs_module_config' );
$page_position	= ( $debug_enabled ) ? '10' : '9';
$active_tab		= ( $debug_enabled ) ? 'true' : 'false';

$sub_menu	= array(
					'id'       		=> 'digitalocean-settings',
					'module'		=> 'DigitalOcean',
					'active'		=> $activated,
					'position'		=> $page_position,
					'template'		=> 'digitalocean-settings',
					'template_path'	=> 'modules/digitalocean/includes/admin/dashboard/config/templates',
					'menu_header'	=> '',
					'menu_divider'	=> '',
					'menu_item'		=> 'DigitalOcean',
					'section_width'	=> '',
					'type'     		=> 'settings',
					'title'    		=> '',
					'subtitle' 		=> '',
					'desc'     		=> '',
					'tab_block_id'	=> 'digitalocean_tabs',
					'tabs'			=> array(
						'tab1'		=>	'Settings',
						'tab2'		=>	'Event Log',
						'tab3'		=>	'Debug',
					),
					'tabs_content'	=> array(
						'tab1'		=>	'digitalocean-settings',
						'tab2'		=>	'digitalocean-logged-data',
						'tab3'		=>	'digitalocean-debug',
					),
					'tabs_active'	=> array(
						'tab1'		=>	'true',
						'tab2'		=>	'true',
						'tab3'		=>	$active_tab,
					),
					'tabs_width'	=> array(
						'tab1'		=>	'xsmall',
						'tab2'		=>	'',
						'tab3'		=>	'',
					),
);

$config[ 'wp-cloud-server-admin-menu' ]['content'][$sub_menu['id']] = $sub_menu;

$config[ 'wp-cloud-server-admin-menu' ]['DigitalOcean'] = $sub_menu;

$sub_menu = array(
	'id'       		=> 'list-cloud-servers',
	'module'		=> 'DigitalOcean',
	'active'		=> $activated,
	'position'		=> '9',
	'template'		=> 'list-cloud-servers',
	'template_path'	=> 'includes/admin/dashboard/config/templates',
	'menu_header'	=> 'Manage',
	'menu_divider'	=> 'yes',
	'menu_item'		=> 'Droplets',
	'section_width'	=> '',
	'type'     		=> 'text',
	'api_required'	=> array( 'digitalocean' ),
	'title'    		=> esc_html__( "DigitalOcean Servers", 'wp-cloud-server' ),
	'subtitle' 		=> '',
	'desc'     		=> '',
	'tab_block_id'	=> 'digitalocean_tabs',
	'tabs'			=> array(
						
						'tab1'		=>	'Droplets',
						'tab2'		=>	'Templates',
						'tab3'		=>	'+ Add Droplet',
						'tab4'		=>	'+ Add Template',
						'tab5'		=>	'Clients',
					),
					'tabs_content'	=> array(
						'tab1'		=>	'list-cloud-servers',
						'tab2'		=>	'list-cloud-server-templates',
						'tab3'		=>	'create-cloud-server',
						'tab4'		=>	'create-cloud-template',
						'tab5'		=>	'list-cloud-client-details',
					),
					'tabs_active'	=> array(
						'tab1'		=>	'true',
						'tab2'		=>	wpcs_cart_active(),
						'tab3'		=>	'true',
						'tab4'		=>	wpcs_cart_active(),
						'tab5'		=>	wpcs_cart_active(),
					),
					'tabs_width'	=> array(
						'tab1'		=>	'',
						'tab2'		=>	'',
						'tab3'		=>	'xsmall',
						'tab4'		=>	'xsmall',
						'tab5'		=>	'',
					),
);

//$config[ 'wp-cloud-server-cloud-servers' ]['DigitalOcean'] = $sub_menu;
$config[ 'wp-cloud-servers-digitalocean' ]['DigitalOcean'][0] = $sub_menu;

$sub_menu = array(
	'id'       		=> 'digitalocean-snapshot-details',
	'module'		=> 'DigitalOcean',
	'active'		=> 'false',
	'position'		=> '9',
	'template'		=> 'digitalocean-snapshot-details',
	'template_path'	=> 'modules/digitalocean/includes/admin/dashboard/config/templates',
	'menu_header'	=> '',
	'menu_divider'	=> '',
	'menu_item'		=> 'Snapshots',
	'section_width'	=> '',
	'type'     		=> 'text',
	'api_required'	=> array( 'digitalocean'),
	'title'    		=> 'DigitalOcean Servers',
	'subtitle' 		=> '',
	'desc'     		=> '',
	'tab_block_id'	=> 'digitalocean_backup_tabs',
			'tabs'			=> array(
				'tab1'		=>	'Snapshots',
				'tab2'		=>	'Backups',
			),
			'tabs_content'	=> array(
				'tab1'		=>	'digitalocean-snapshot-details',
				'tab2'		=>	'digitalocean-backup-details',
			),
			'tabs_active'	=> array(
				'tab1'		=>	'true',
				'tab2'		=>	'true',
			),
			'tabs_width'	=> array(
				'tab1'		=>	'',
				'tab2'		=>	'',
			),
);

$config[ 'wp-cloud-servers-digitalocean' ]['DigitalOcean'][1] = $sub_menu;

/*
 * <--- END MENU CONFIGURATION
 */

if ( function_exists( 'wpcs_setup_digitalocean_pro_config' ) ) {
	$config = wpcs_setup_digitalocean_pro_config( $config );
}

update_option( 'wpcs_module_config', $config );
	
do_action( 'wpcs_update_module_status', $module_name, $status );
}
add_action( 'wpcs_update_module_config', 'wpcs_setup_digitalocean_config', 10, 3 );

function wpcs_digitalocean_snapshot_upgrade() {		
	?>
	<div class="uk-overflow-auto">
		<h2 class="uk-margin-remove-top uk-heading-divider"><?php _e( 'DigitalOcean Snapshots', 'wp-cloud-server' ); ?></h2>
		<div class="uk-alert-upgrade" uk-alert>
			<p>DigitalOcean Snapshots are available with the DigitalOcean Pro Module. Please <a href="#">click here</a> for more information</p>
		</div>
	</div>
    <?php	
}
add_action( 'wpcs_digitalocean_snapshot_content', 'wpcs_digitalocean_snapshot_upgrade' );

function wpcs_digitalocean_backup_upgrade() {		
	?>
	<div class="uk-overflow-auto">
		<h2 class="uk-margin-remove-top uk-heading-divider"><?php _e( 'DigitalOcean Backups', 'wp-cloud-server' ); ?></h2>
		<div class="uk-alert-upgrade" uk-alert>
			<p>DigitalOcean Backups are available with the DigitalOcean Pro Module. Please <a href="#">click here</a> for more information</p>
		</div>
	</div>
    <?php	
}
add_action( 'wpcs_digitalocean_backup_content', 'wpcs_digitalocean_backup_upgrade' );