<?php
/**
 * WP Cloud Server Config File
 *
 */

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) exit;

function wpcs_setup_linode_config( $modules, $module_name, $status ) {

$debug_enabled = get_option( 'wpcs_enable_debug_mode' );

/**
 * GLOBAL ARGUMENTS
 */

$kses_exceptions = array(
	'a'      => array(
		'href' => array(),
	),
	'strong' => array(),
	'br'     => array(),
);

require_once WPCS_LINODE_PLUGIN_DIR . 'includes/config/templates/linode-settings.php';
require_once WPCS_LINODE_PLUGIN_DIR . 'includes/config/templates/linode-logged-data.php';
require_once WPCS_LINODE_PLUGIN_DIR . 'includes/config/templates/linode-debug.php';
require_once WPCS_LINODE_PLUGIN_DIR . 'includes/config/templates/linode-server-details.php';
require_once WPCS_LINODE_PLUGIN_DIR . 'includes/config/templates/linode-client-details.php';
require_once WPCS_LINODE_PLUGIN_DIR . 'includes/config/templates/linode-create-server.php';
require_once WPCS_LINODE_PLUGIN_DIR . 'includes/config/templates/linode-create-template.php';
require_once WPCS_LINODE_PLUGIN_DIR . 'includes/config/templates/linode-template-details.php';
require_once WPCS_LINODE_PLUGIN_DIR . 'includes/config/templates/linode-list-server-details.php';
	
require_once WPCS_LINODE_PLUGIN_DIR . 'includes/config/templates/linode-backup-details.php';
require_once WPCS_LINODE_PLUGIN_DIR . 'includes/config/templates/linode-snapshot-details.php';

/*
 *
 * ---> BEGIN SECTIONS
 *
 */

/* -> START WordPress Sub Menu. */

if ( ( 'Linode' == $module_name ) && ( '' !== $status ) ) {
	$modules[$module_name]['status'] = $status;
	update_option( 'wpcs_module_list', $modules );
}

$modules	= get_option( 'wpcs_module_list' );

$activated	= ( isset( $modules['Linode']['status'] ) && ( 'active' == $modules['Linode']['status'] ) ) ? 'true' : 'false';

//delete_option( 'wpcs_module_config' );

$config		= get_option( 'wpcs_module_config' );

$page_position = ( $debug_enabled ) ? '10' : '9';
$active_tab		= ( $debug_enabled ) ? 'true' : 'false';

$sub_menu = array(
	'id'       		=> 'linode-settings',
	'module'		=> 'Linode',
	'active'		=> $activated,
	'position'		=> $page_position,
	'template'		=> 'linode-settings',
	'template_path'	=> 'includes/config/templates/',
	'menu_header'	=> '',
	'menu_divider'	=> '',
	'menu_item'		=> 'Linode',
	'section_width'	=> '',
	'type'     		=> 'settings',
	'title'    		=> '',
	'subtitle' 		=> '',
	'desc'     		=> '',
	'tab_block_id'	=> 'linode_tabs',
	'tabs'			=> array(
		'tab1'		=>	'Settings',
		'tab2'		=>	'Event Log',
		'tab3'		=>	'Debug',
	),
	'tabs_content'	=> array(
		'tab1'		=>	'linode-settings',
		'tab2'		=>	'linode-logged-data',
		'tab3'		=>	'linode-debug',
	),
	'tabs_active'	=> array(
		'tab1'		=>	'true',
		'tab2'		=>	'true',
		'tab3'		=>	$active_tab,
	),
	'tabs_width'	=> array(
		'tab1'		=>	'xsmall',
		'tab2'		=>	'',
		'tab3'		=>	'',
	),
);

$config[ 'wp-cloud-server-admin-menu' ]['content'][$sub_menu['id']] = $sub_menu;

$config[ 'wp-cloud-server-admin-menu' ]['Linode'] = $sub_menu;

$linode[$sub_menu['id']] = $sub_menu;

$sub_menu = array(
			'id'       		=> 'linode-server-details',
			'module'		=> 'Linode',
			'active'		=> $activated,
			'position'		=> '9',
			'template'		=> 'linode-server-details',
			'template_path'	=> 'includes/config/templates',
			'menu_header'	=> 'Manage',
			'menu_divider'	=> 'yes',
			'menu_item'		=> 'Linodes',
			'section_width'	=> '',
			'type'     		=> 'text',
			'api_required'	=> array( 'linode'),
			'title'    		=> 'Linode Linux Servers',
			'subtitle' 		=> '',
			'desc'     		=> '',
			'tab_block_id'	=> 'linode_tabs',
					'tabs'			=> array(
						
						'tab1'		=>	'Servers',
						'tab2'		=>	'Templates',
						'tab3'		=>	'+ Add Server',
						'tab4'		=>	'+ Add Template',
						'tab5'		=>	'Clients',
					),
					'tabs_content'	=> array(
						'tab1'		=>	'linode-server-details',
						'tab2'		=>	'linode-template-details',
						'tab3'		=>	'linode-create-server',
						'tab4'		=>	'linode-create-template',
						'tab5'		=>	'linode-client-details',
					),
					'tabs_active'	=> array(
						'tab1'		=>	'true',
						'tab2'		=>	wpcs_cart_active(),
						'tab3'		=>	'true',
						'tab4'		=>	wpcs_cart_active(),
						'tab5'		=>	wpcs_cart_active(),
					),
					'tabs_width'	=> array(
						'tab1'		=>	'',
						'tab2'		=>	'',
						'tab3'		=>	'xsmall',
						'tab4'		=>	'xsmall',
						'tab5'		=>	'',
					),
		);

//$config[ 'wp-cloud-server-cloud-servers' ]['Linode'] = $sub_menu;
$config[ 'wp-cloud-servers-linode' ]['Linode'][0] = $sub_menu;
	
$sub_menu = array(
			'id'       		=> 'linode-backup-details',
			'module'		=> 'Linode',
			'active'		=> 'false',
			'position'		=> '9',
			'template'		=> 'linode-backup-details',
			'template_path'	=> 'includes/config/templates',
			'menu_header'	=> '',
			'menu_divider'	=> '',
			'menu_item'		=> 'Snapshots',
			'section_width'	=> '',
			'type'     		=> 'text',
			'api_required'	=> array( 'linode'),
			'title'    		=> 'Linode Servers',
			'subtitle' 		=> '',
			'desc'     		=> '',
			'tab_block_id'	=> 'linode_backup_tabs',
					'tabs'			=> array(
						'tab1'		=>	'Snapshots',
						'tab2'		=>	'Backups',
					),
					'tabs_content'	=> array(
						'tab1'		=>	'linode-snapshot-details',
						'tab2'		=>	'linode-backup-details',
					),
					'tabs_active'	=> array(
						'tab1'		=>	'true',
						'tab2'		=>	'true',
					),
					'tabs_width'	=> array(
						'tab1'		=>	'',
						'tab2'		=>	'',
					),
);

$config[ 'wp-cloud-servers-linode' ]['Linode'][1] = $sub_menu;

/*
 * <--- END MENU CONFIGURATION
 */

if ( function_exists( 'wpcs_setup_linode_pro_config' ) ) {
	$config = wpcs_setup_linode_pro_config( $config );
}

update_option( 'wpcs_linode_module_config', $linode );

update_option( 'wpcs_module_config', $config );

}
add_action( 'wpcs_update_module_config', 'wpcs_setup_linode_config', 10, 3 );