<?php
/**
 * WP Cloud Server - Linode Module Uninstall
 *
 * @author		Gary Jordan (gary@designedforpixels.com)
 * @since      	1.3.0
 *
 * @package    	WP_Cloud_Server_Linode
 */

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) exit;

if ( ! defined( 'WP_UNINSTALL_PLUGIN' ) ) exit();

function wpcs_uninstall_linode_plugin() {
	
	$delete_data_confirmed = get_option( 'wpcs_uninstall_data_confirmed' );
	
	delete_option( 'wpcs_linode_server_complete_queue' );
	delete_transient( 'wpcs_linode_api_health' );
	
	// Clear the Server Completed Queue
	wp_clear_scheduled_hook( 'wpcs_linode_run_server_completed_queue' );
	
	if ( $delete_data_confirmed ) {
	
		// Delete the Log Files
		// Delete the Linode Module from the main Module List
	$module_list = get_option( 'wpcs_module_list' );
	unset( $module_list[ 'Linode' ] );
	update_option( 'wpcs_module_list', $module_list );
	
	// Delete the Log Files
	delete_option( 'wpcs_linode_log_event' );
    delete_transient( 'wpcs_upgrade_wp-cloud-server-linode' );
	
	// Delete the Linode Module Options
	delete_transient( 'wpcs_linode_api_health' );
	
	delete_option( 'wpcs_linode_api_health_check_failed' );
	delete_option( 'wpcs_dismissed_linode_api_notice' );
	delete_option( 'wpcs_dismissed_linode_notice' );
	delete_option( 'wpcs_linode_api_last_health_response' );
	delete_option( 'wpcs_linode_api_last_response' );
	delete_option( 'wpcs_linode_server_attached' );
	delete_option( 'wpcs_linode_api_token' );
	delete_option( 'wpcs_dismissed_linode_module_setup_notice' );
	delete_option( 'wpcs_linode_server_name' );
	delete_option( 'wpcs_linode_server_type' );	
	delete_option( 'wpcs_linode_server_region' );
	delete_option( 'wpcs_linode_server_size' );
	delete_option( 'wpcs_linode_template_name' );
	delete_option( 'wpcs_linode_template_type' );	
	delete_option( 'wpcs_linode_template_region' );
	delete_option( 'wpcs_linode_template_size' );
	delete_option( 'wpcs_linode_api_token' );
	delete_option( 'wpcs_linode_logged_data' );
	delete_option( 'wpcs_linode_new_site_created' );
		
	}

}

wpcs_uninstall_linode_plugin();