<?php
/**
 * WP Cloud Server Config File
 *
 */

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) exit;

function wpcs_setup_runcloud_config( $modules, $module_name, $status ) {

$debug_enabled = get_option( 'wpcs_enable_debug_mode' );

/**
 * GLOBAL ARGUMENTS
 */

$kses_exceptions = array(
	'a'      => array(
		'href' => array(),
	),
	'strong' => array(),
	'br'     => array(),
);

require_once WPCS_RUNCLOUD_PLUGIN_DIR . 'includes/config/templates/runcloud-settings.php';
require_once WPCS_RUNCLOUD_PLUGIN_DIR . 'includes/config/templates/runcloud-logged-data.php';
require_once WPCS_RUNCLOUD_PLUGIN_DIR . 'includes/config/templates/runcloud-debug.php';
require_once WPCS_RUNCLOUD_PLUGIN_DIR . 'includes/config/templates/runcloud-server-details.php';

require_once WPCS_RUNCLOUD_PLUGIN_DIR . 'includes/config/templates/runcloud-list-managed-websites.php';
require_once WPCS_RUNCLOUD_PLUGIN_DIR . 'includes/config/templates/runcloud-list-managed-servers.php';
require_once WPCS_RUNCLOUD_PLUGIN_DIR . 'includes/config/templates/runcloud-list-managed-templates.php';
require_once WPCS_RUNCLOUD_PLUGIN_DIR . 'includes/config/templates/runcloud-list-website-templates.php';
require_once WPCS_RUNCLOUD_PLUGIN_DIR . 'includes/config/templates/runcloud-install-managed-website.php';
require_once WPCS_RUNCLOUD_PLUGIN_DIR . 'includes/config/templates/runcloud-connect-managed-server.php';
require_once WPCS_RUNCLOUD_PLUGIN_DIR . 'includes/config/templates/runcloud-create-managed-template.php';
require_once WPCS_RUNCLOUD_PLUGIN_DIR . 'includes/config/templates/runcloud-create-web-app-template.php';
require_once WPCS_RUNCLOUD_PLUGIN_DIR . 'includes/config/templates/runcloud-client-details.php';
	
require_once WPCS_RUNCLOUD_PLUGIN_DIR . 'includes/config/templates/runcloud-sysuser-details.php';

/*
 *
 * ---> BEGIN SECTIONS
 *
 */

/* -> START WordPress Sub Menu. */
//update_option( 'wpcs_runcloud_server_complete_queue', array() );

if ( ( 'RunCloud' == $module_name ) && ( '' !== $status ) ) {
	$modules[$module_name]['status'] = $status;
	update_option( 'wpcs_module_list', $modules );
}

$modules	= get_option( 'wpcs_module_list' );

$activated	= ( isset($modules['RunCloud']['status']) && ( 'active' == $modules['RunCloud']['status'] ) ) ? 'true' : 'false';

//delete_option( 'wpcs_module_config' );

$config		= get_option( 'wpcs_module_config' );

$page_position = ( $debug_enabled ) ? '10' : '9';
$active_tab		= ( $debug_enabled ) ? 'true' : 'false';

$sub_menu = array(
	'id'       		=> 'runcloud-settings',
	'module'		=> 'RunCloud',
	'active'		=> $activated,
	'position'		=> $page_position,
	'template'		=> 'runcloud-settings',
	'template_path'	=> 'includes/config/templates/',
	'menu_header'	=> '',
	'menu_divider'	=> '',
	'menu_item'		=> 'RunCloud',
	'type'     		=> 'settings',
	'title'    		=> '',
	'subtitle' 		=> '',
	'desc'     		=> '',
	'tab_block_id'	=> 'runcloud_tabs',
	'tabs'			=> array(
		'tab1'		=>	'Settings',
		'tab2'		=>	'Event Log',
		'tab3'		=>	'Debug',
	),
	'tabs_content'	=> array(
		'tab1'		=>	'runcloud-settings',
		'tab2'		=>	'runcloud-logged-data',
		'tab3'		=>	'runcloud-debug',
	),
	'tabs_active'	=> array(
		'tab1'		=>	'true',
		'tab2'		=>	'true',
		'tab3'		=>	$active_tab,
	),
	'tabs_width'	=> array(
		'tab1'		=>	'xsmall',
		'tab2'		=>	'',
		'tab3'		=>	'',
	),
);

$config[ 'wp-cloud-server-admin-menu' ]['content'][$sub_menu['id']] = $sub_menu;

$config[ 'wp-cloud-server-admin-menu' ]['RunCloud'] = $sub_menu;

$runcloud[$sub_menu['id']] = $sub_menu;

$sub_menu = array(
	'id'       		=> 'install-website',
	'module'		=> 'RunCloud',
	'active'		=> $activated,
	'position'		=> '6',
	'template'		=> 'install-website',
	'template_path'	=> 'includes/config/templates',	
	'menu_header'	=> 'Manage',
	'menu_divider'	=> 'yes',
	'menu_item'		=> 'Servers',
	'type'     		=> 'text',
	'api_required'	=> array( 'runcloud'),
	'section_width'	=> '',
	'content_width'	=> 'xsmall',
	'title'    		=> '',
	'subtitle' 		=> '',
	'desc'     		=> '',
					'tab_block_id'	=> 'runcloud_tabs',
					'tabs'			=> array(
						'tab1'		=>	'Servers',
						'tab2'		=>	'Templates',
						'tab3'		=>	'+ Add Server',
						'tab4'		=>	'+ Add Template',
						'tab5'		=>	'Clients',
					),
					'tabs_content'	=> array(
						'tab1'		=>	'runcloud-list-managed-servers',
						'tab2'		=>	'runcloud-list-managed-templates',
						'tab3'		=>	'runcloud-connect-managed-server',
						'tab4'		=>	'runcloud-create-managed-template',
						'tab5'		=>	'runcloud-client-details',
					),
					'tabs_active'	=> array(
						'tab1'		=>	'true',
						'tab2'		=>	wpcs_cart_active(),
						'tab3'		=>	'true',
						'tab4'		=>	wpcs_cart_active(),
						'tab5'		=>	wpcs_cart_active(),
					),
					'tabs_width'	=> array(
						'tab1'		=>	'',
						'tab2'		=>	'',
						'tab3'		=>	'xsmall',
						'tab4'		=>	'xsmall',
						'tab5'		=>	'',
					),
);

$config[ 'wp-cloud-servers-runcloud' ]['RunCloud'][0] = $sub_menu;
	
$sub_menu = array(
	'id'       		=> 'install-website',
	'module'		=> 'RunCloud',
	'active'		=> 'true',
	'position'		=> '6',
	'template'		=> 'install-website',
	'template_path'	=> 'includes/config/templates',	
	'menu_header'	=> '',
	'menu_divider'	=> '',
	'menu_item'		=> 'Web Applications',
	'type'     		=> 'text',
	'api_required'	=> array( 'runcloud'),
	'section_width'	=> '',
	'content_width'	=> 'xsmall',
	'title'    		=> '',
	'subtitle' 		=> '',
	'desc'     		=> '',
					'tab_block_id'	=> 'runcloud_website_tabs',
					'tabs'			=> array(
						'tab1'		=>	'Websites',
						'tab2'		=>	'+ Add Website',
					),
					'tabs_content'	=> array(
						'tab1'		=>	'runcloud-list-managed-websites',
						'tab2'		=>	'runcloud-install-managed-website',
					),
					'tabs_active'	=> array(
						'tab1'		=>	'true',
						'tab2'		=>	'true',
					),
					'tabs_width'	=> array(
						'tab1'		=>	'',
						'tab2'		=>	'xsmall',
					),
);

$config[ 'wp-cloud-servers-runcloud' ]['RunCloud'][1] = $sub_menu;
	
$sub_menu = array(
	'id'       		=> 'runcloud-sysuser-details',
	'module'		=> 'RunCloud',
	'active'		=> 'false',
	'position'		=> '6',
	'template'		=> 'runcloud-sysuser-details',
	'template_path'	=> 'includes/config/templates',	
	'menu_header'	=> '',
	'menu_divider'	=> '',
	'menu_item'		=> 'System Users',
	'type'     		=> 'text',
	'api_required'	=> array( 'runcloud'),
	'section_width'	=> '',
	'content_width'	=> 'xsmall',
	'title'    		=> '',
	'subtitle' 		=> '',
	'desc'     		=> '',
	'tab_block_id'	=> 'runcloud_sysuser_tabs',
					'tabs'			=> array(
						'tab1'		=>	'System Users',
						'tab2'		=>	'+ Add System User',
					),
					'tabs_content'	=> array(
						'tab1'		=>	'runcloud-sysuser-details',
						'tab2'		=>	'runcloud-sysuser-details',
					),
					'tabs_active'	=> array(
						'tab1'		=>	'true',
						'tab2'		=>	'true',
					),
					'tabs_width'	=> array(
						'tab1'		=>	'',
						'tab2'		=>	'',
					),
);

$config[ 'wp-cloud-servers-runcloud' ]['RunCloud'][2] = $sub_menu;

/*
 * <--- END MENU CONFIGURATION
 */

if ( function_exists( 'wpcs_setup_runcloud_pro_config' ) ) {
	$config = wpcs_setup_runcloud_pro_config( $config );
}

update_option( 'wpcs_runcloud_module_config', $runcloud );

update_option( 'wpcs_module_config', $config );

}
add_action( 'wpcs_update_module_config', 'wpcs_setup_runcloud_config', 10, 3 );