<?php
/**
 * WP Cloud Server ServerPilot Config File
 *
 */

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) exit;

function wpcs_setup_serverpilot_config( $modules, $module_name, $status ) {

/**
 * GLOBAL ARGUMENTS
 */

$kses_exceptions = array(
	'a'      => array(
		'href' => array(),
	),
	'strong' => array(),
	'br'     => array(),
);

/*
 *
 * ---> BEGIN SECTIONS
 *
 */

/* -> START WordPress Sub Menu. */
	
if ( ( 'ServerPilot' == $module_name ) && ( '' !== $status ) ) {
	$modules[$module_name]['status'] = $status;
	update_option( 'wpcs_module_list', $modules );
}

//$modules		= get_option( 'wpcs_module_list' );
$config			= get_option( 'wpcs_module_config' );
$debug_enabled	= get_option( 'wpcs_enable_debug_mode' );
$active_tab		= ( $debug_enabled ) ? 'true' : 'false';
$activated		= ( isset( $modules['ServerPilot']['status'] ) && ( 'active' == $modules['ServerPilot']['status'] ) ) ? 'true' : 'false';
$ecommerce		= wpcs_cart_active();

$serverpilot_active		= ( isset($modules['ServerPilot']['status']) && ( 'active' == $modules['ServerPilot']['status'] ) );
$digitalocean_active	= ( isset($modules['DigitalOcean']['status']) && ( 'active' == $modules['DigitalOcean']['status'] ) );
$cloudways_active		= ( isset($modules['Cloudways']['status']) && ( 'active' == $modules['Cloudways']['status'] ) );

$api_status				= wpcs_check_cloud_provider_api( null, null, true, $modules);
$cloud_active			= wpcs_check_cloud_provider_api( null, null, true);

foreach ( $modules as $key => $module ) {
	if ( 'active' == $module['status'] ) {
		$modules_available = true;
	}
}

$module_menu_active = ( isset( $modules_available ) && $modules_available ) ? 'true' : 'false';
	
$page_position = '5';

$sub_menu = array(
	'id'       		=> 'serverpilot-settings',
	'active'		=> $activated,
	'module'		=> 'ServerPilot',
	'position'		=> $page_position,
	'template'		=> 'serverpilot-settings',
	'template_path'	=> 'modules/serverpilot/includes/admin/dashboard/config/templates',
	'menu_active'	=> $module_menu_active,
	'menu_header'	=> 'Modules',
	'menu_divider'	=> 'yes',
	'menu_item'		=> 'ServerPilot',
	'section_width'	=> '',
	'type'     		=> 'settings',
	'title'    		=> '',
	'subtitle' 		=> '',
	'desc'     		=> '',
	'tab_block_id'	=> 'serverpilot_tabs',
	'tabs'			=> array(
		'tab1'		=>	'Settings',
		'tab2'		=>	'Event Log',
		'tab3'		=>	'Debug',
	),
	'tabs_content'	=> array(
		'tab1'		=>	'serverpilot-settings',
		'tab2'		=>	'serverpilot-logged-data',
		'tab3'		=>	'serverpilot-debug',
	),
	'tabs_active'	=> array(
		'tab1'		=>	'true',
		'tab2'		=>	'true',
		'tab3'		=>	$active_tab,
	),
	'tabs_width'	=> array(
		'tab1'		=>	'xsmall',
		'tab2'		=>	'',
		'tab3'		=>	'',
	),
);

$config[ 'wp-cloud-server-admin-menu' ]['content'][$sub_menu['id']] = $sub_menu;

$config[ 'wp-cloud-server-admin-menu' ]['ServerPilot'] = $sub_menu;

$sub_menu = array(
	'id'       		=> 'installed-websites',
	'module'		=> 'ServerPilot',
	'active'		=> 'true',
	'position'		=> '11',
	'template'		=> 'installed-websites',
	'template_path'	=> 'includes/admin/dashboard/config/templates',
	'menu_header'	=> 'Manage',
	'menu_divider'	=> 'yes',
	'menu_item'		=> 'Servers',
	'section_width'	=> '',
	'type'     		=> 'text',
	'api_required'	=> array( 'serverpilot', 'cloud_provider'),
	'title'    		=> esc_html__( 'Installed Websites', 'wp-cloud-server' ),
	'subtitle' 		=> '',
	'desc'     		=> '',
	'tab_block_id'	=> 'serverpilot_tabs',
					'tabs'			=> array(
						'tab1'		=>	'Servers',
						'tab2'		=>	'Templates',
						'tab3'		=>	'+ Add Server',
						'tab4'		=>	'+ Add Template',
						'tab5'		=>	'Clients',
					),
					'tabs_content'	=> array(
						'tab1'		=>	'list-managed-servers',
						'tab2'		=>	'list-managed-server-templates',
						'tab3'		=>	'create-managed-server',
						'tab4'		=>	'create-managed-template',
						'tab5'		=>	'list-managed-client-details',
					),
					'tabs_active'	=> array(
						'tab1'		=>	'true',
						'tab2'		=>	wpcs_cart_active(),
						'tab3'		=>	'true',
						'tab4'		=>	wpcs_cart_active(),
						'tab5'		=>	wpcs_cart_active(),
					),
					'tabs_width'	=> array(
						'tab1'		=>	'',
						'tab2'		=>	'',
						'tab3'		=>	'xsmall',
						'tab4'		=>	'xsmall',
						'tab5'		=>	'',
					),
);

$config[ 'wp-cloud-servers-serverpilot' ]['ServerPilot'][0] = $sub_menu;
	
$sub_menu = array(
	'id'       		=> 'list-managed-apps',
	'module'		=> 'ServerPilot',
	'active'		=> 'true',
	'position'		=> '11',
	'template'		=> 'list-managed-apps',
	'template_path'	=> 'includes/admin/dashboard/config/templates',
	'menu_header'	=> '',
	'menu_divider'	=> '',
	'menu_item'		=> 'Apps',
	'section_width'	=> '',
	'type'     		=> 'text',
	'api_required'	=> array( 'serverpilot', 'cloud_provider'),
	'title'    		=> esc_html__( 'Installed Websites', 'wp-cloud-server' ),
	'subtitle' 		=> '',
	'desc'     		=> '',
	'tab_block_id'	=> 'serverpilot_apps_tabs',
					'tabs'			=> array(
						'tab1'		=>	'Apps',
						'tab2'		=>	'+ Add App',
					),
					'tabs_content'	=> array(
						'tab1'		=>	'list-managed-apps',
						'tab2'		=>	'create-managed-app',
					),
					'tabs_active'	=> array(
						'tab1'		=>	'true',
						'tab2'		=>	'true',
					),
					'tabs_width'	=> array(
						'tab1'		=>	'',
						'tab2'		=>	'xsmall',
					),
);

$config[ 'wp-cloud-servers-serverpilot' ]['ServerPilot'][1] = $sub_menu;

/*
 * <--- END MENU CONFIGURATION
 */
	
update_option( 'wpcs_module_config', $config );
}
add_action( 'wpcs_update_module_config', 'wpcs_setup_serverpilot_config', 10, 3 );