<?php
/**
 * WP Cloud Server Config File
 *
 */

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) exit;

function wpcs_setup_vultr_config( $modules, $module_name, $status ) {

$debug_enabled = get_option( 'wpcs_enable_debug_mode' );

/**
 * GLOBAL ARGUMENTS
 */

$kses_exceptions = array(
	'a'      => array(
		'href' => array(),
	),
	'strong' => array(),
	'br'     => array(),
);

require_once WPCS_VULTR_PLUGIN_DIR . 'includes/config/templates/vultr-settings.php';
require_once WPCS_VULTR_PLUGIN_DIR . 'includes/config/templates/vultr-license-settings.php';
require_once WPCS_VULTR_PLUGIN_DIR . 'includes/config/templates/vultr-logged-data.php';
require_once WPCS_VULTR_PLUGIN_DIR . 'includes/config/templates/vultr-debug.php';
require_once WPCS_VULTR_PLUGIN_DIR . 'includes/config/templates/vultr-server-details.php';
require_once WPCS_VULTR_PLUGIN_DIR . 'includes/config/templates/vultr-template-details.php';
require_once WPCS_VULTR_PLUGIN_DIR . 'includes/config/templates/vultr-create-server.php';
require_once WPCS_VULTR_PLUGIN_DIR . 'includes/config/templates/vultr-create-template.php';
require_once WPCS_VULTR_PLUGIN_DIR . 'includes/config/templates/vultr-client-details.php';
	
require_once WPCS_VULTR_PLUGIN_DIR . 'includes/config/templates/vultr-backup-details.php';
require_once WPCS_VULTR_PLUGIN_DIR . 'includes/config/templates/vultr-snapshot-details.php';

/*
 *
 * ---> BEGIN SECTIONS
 *
 */

/* -> START WordPress Sub Menu. */
//update_option( 'wpcs_vultr_server_complete_queue', array() );

if ( ( 'Vultr' == $module_name ) && ( '' !== $status ) ) {
	$modules[$module_name]['status'] = $status;
	update_option( 'wpcs_module_list', $modules );
}

$modules	= get_option( 'wpcs_module_list' );

$activated	= ( isset($modules['Vultr']['status']) && ( 'active' == $modules['Vultr']['status'] ) ) ? 'true' : 'false';
	
// Check if Vultr Pro Module is active
$vultr_pro_active = check_vultr_pro_plugin();

//delete_option( 'wpcs_module_config' );

$config		= get_option( 'wpcs_module_config' );

$page_position = ( $debug_enabled ) ? '10' : '9';
$active_tab		= ( $debug_enabled ) ? 'true' : 'false';

$sub_menu = array(
	'id'       		=> 'vultr-settings',
	'module'		=> 'Vultr',
	'active'		=> $activated,
	'position'		=> $page_position,
	'template'		=> 'vultr-settings',
	'template_path'	=> 'includes/config/templates/',
	'menu_header'	=> '',
	'menu_divider'	=> '',
	'menu_item'		=> 'Vultr',
	'section_width'	=> '',
	'type'     		=> 'settings',
	'title'    		=> '',
	'subtitle' 		=> '',
	'desc'     		=> '',
	'tab_block_id'	=> 'vultr_tabs',
	'tabs'			=> array(
		'tab1'		=>	'Settings',
		'tab2'		=>	'License',
		'tab3'		=>	'Event Log',
		'tab4'		=>	'Debug',
	),
	'tabs_content'	=> array(
		'tab1'		=>	'vultr-settings',
		'tab2'		=>	'vultr-license-settings',		
		'tab3'		=>	'vultr-logged-data',
		'tab4'		=>	'vultr-debug',
	),
	'tabs_active'	=> array(
		'tab1'		=>	'true',
		'tab2'		=>	$vultr_pro_active,
		'tab3'		=>	'true',
		'tab4'		=>	$active_tab,
	),
	'tabs_width'	=> array(
		'tab1'		=>	'xsmall',
		'tab2'		=>	'',
		'tab3'		=>	'',
		'tab4'		=>	'',		
	),
);

$config[ 'wp-cloud-server-admin-menu' ]['content'][$sub_menu['id']] = $sub_menu;

$config[ 'wp-cloud-server-admin-menu' ]['Vultr'] = $sub_menu;

$vultr[$sub_menu['id']] = $sub_menu;

$sub_menu = array(
			'id'       		=> 'vultr-server-details',
			'module'		=> 'Vultr',
			'active'		=> $activated,
			'position'		=> '9',
			'template'		=> 'vultr-server-details',
			'template_path'	=> 'includes/config/templates',
			'menu_header'	=> 'Manage',
			'menu_divider'	=> 'yes',
			'menu_item'		=> 'Instances',
			'section_width'	=> '',
			'type'     		=> 'text',
			'api_required'	=> array( 'vultr'),
			'title'    		=> 'Vultr Servers',
			'subtitle' 		=> '',
			'desc'     		=> '',
			'tab_block_id'	=> 'vultr_tabs',
					'tabs'			=> array(
						'tab1'		=>	'Servers',
						'tab2'		=>	'Templates',
						'tab3'		=>	'+ Add Server',
						'tab4'		=>	'+ Add Template',
						'tab5'		=>	'Clients',
					),
					'tabs_content'	=> array(
						'tab1'		=>	'vultr-server-details',
						'tab2'		=>	'vultr-template-details',
						'tab3'		=>	'vultr-create-server',
						'tab4'		=>	'vultr-create-template',
						'tab5'		=>	'vultr-client-details',
					),
					'tabs_active'	=> array(
						'tab1'		=>	'true',
						'tab2'		=>	wpcs_cart_active(),
						'tab3'		=>	'true',
						'tab4'		=>	wpcs_cart_active(),
						'tab5'		=>	wpcs_cart_active(),
					),
					'tabs_width'	=> array(
						'tab1'		=>	'',
						'tab2'		=>	'',
						'tab3'		=>	'xsmall',
						'tab4'		=>	'xsmall',
						'tab5'		=>	'',
					),
);

$config[ 'wp-cloud-servers-vultr' ]['Vultr'][0] = $sub_menu;
	
// Upgrade Menus
	
$sub_menu = array(
			'id'       		=> 'vultr-backup-details',
			'module'		=> 'Vultr',
			'active'		=> 'false',
			'position'		=> '9',
			'template'		=> 'vultr-backup-details',
			'template_path'	=> 'includes/config/templates',
			'menu_header'	=> '',
			'menu_divider'	=> '',
			'menu_item'		=> 'Snapshots',
			'section_width'	=> '',
			'type'     		=> 'text',
			'api_required'	=> array( 'vultr'),
			'title'    		=> 'Vultr Servers',
			'subtitle' 		=> '',
			'desc'     		=> '',
			'tab_block_id'	=> 'vultr_backup_tabs',
					'tabs'			=> array(
						'tab1'		=>	'Snapshots',
						'tab2'		=>	'Backups',
					),
					'tabs_content'	=> array(
						'tab1'		=>	'vultr-snapshot-details',
						'tab2'		=>	'vultr-backup-details',
					),
					'tabs_active'	=> array(
						'tab1'		=>	'true',
						'tab2'		=>	'true',
					),
					'tabs_width'	=> array(
						'tab1'		=>	'',
						'tab2'		=>	'',
					),
);

$config[ 'wp-cloud-servers-vultr' ]['Vultr'][1] = $sub_menu;

/*
 * <--- END MENU CONFIGURATION
 */

if ( function_exists( 'wpcs_setup_vultr_pro_config' ) ) {
	$config = wpcs_setup_vultr_pro_config( $config );
}

update_option( 'wpcs_module_config', $config );

}
add_action( 'wpcs_update_module_config', 'wpcs_setup_vultr_config', 10, 3 );