<?php

function wpcs_vultr_settings_template ( $tabs_content ) {
	
	if ( 'vultr-settings' !== $tabs_content ) {
		return;
	}

	$nonce		= isset( $_GET['_wpnonce'] ) ? sanitize_text_field( $_GET['_wpnonce'] ) : ''; 
	$reset_api	= isset( $_GET['resetapi'] ) ? sanitize_text_field( $_GET['resetapi'] ) : '';
	$module		= isset( $_GET['module'] ) ? sanitize_text_field( $_GET['module'] ) : '';
	
	if ( ( wp_verify_nonce( $nonce, 'vultr_settings_nonce' ) ) && ( 'vultr' == $module ) && ( 'true' == $reset_api ) && ( current_user_can( 'manage_options' ) ) ) {
		delete_option( 'wpcs_vultr_api_token' );
		delete_option( 'wpcs_dismissed_vultr_api_notice' );
		echo '<script type="text/javascript"> window.location.href =  window.location.href.split("&")[0]; </script>';
	}
	?>

		<div class="content">
			<form method="post" action="options.php">
				<?php 
				wpcs_settings_fields( 'wpcs_vultr_admin_menu', 'vultr' );
				wpcs_do_settings_sections( 'wpcs_vultr_admin_menu' );
				?>
				<hr>
				<?php
				wpcs_submit_button( 'Save Settings', 'secondary', 'create_vultr_api' );
				?>
			</form>
		</div>
		<p>
			<a class="uk-link" href="<?php echo esc_url( wp_nonce_url( self_admin_url( 'admin.php?page=wp-cloud-server-admin-menu&module=vultr&resetapi=true' ), 'vultr_settings_nonce', '_wpnonce') );?>"><?php esc_attr_e( 'Reset Vultr API Credentials', 'wp-cloud-server' ) ?></a>
		</p>

<?php
}
add_action( 'wpcs_control_panel_tab_content', 'wpcs_vultr_settings_template' );